var Backbone = require('backbone')

module.exports = function(options) {
  var that = this

  that.config = {
    history: {
      pushState: true
    },
    trigger: true
  }

  that.initialize = function() {}

  if (options.initialize) {
    that.initialize = options.initialize
  }

  if (options.router) {
    that.router = options.router
  }
  
  if (options.trigger) {
    that.config.trigger = trigger
  }

  that.run = function() {
    that.initialize()
    Backbone.history.start(that.config.history)

    if (that.config.trigger) {
      that.router.transition(that.router.routes[Backbone.history.fragment])
    }  
  }
}
