var fs = require('fs')
  , path = require('path')
  , stitch = require('stitch')

var Handlebars = require('handlebars')

var createPackageFn = stitch.createPackage

stitch.createPackage = function(config) {
  var liloModulePath = path.join(
    __dirname,
    '..',
    '..',
    'node_modules'
  )

  if (typeof(config) === 'undefined') {
    config = { paths: [], dependencies: [] }
  }
  if (!config.paths) {
    config.paths = []
  }
  if (!config.dependencies) {
    config.dependencies = []
  }

  config.dependencies = config.dependencies.concat([
    path.join(liloModulePath, 'handlebars', 'dist', 'handlebars.runtime.js'),
  ])

  config.paths = config.paths.concat([ 
    path.join(liloModulePath, 'backbone'),
    path.join(liloModulePath, 'handlebars', 'dist'),
    path.join(liloModulePath, 'underscore'),
    path.join(__dirname, '..', 'client'),
    'app',
  ])

  config.compilers = {
    handlebars: function(module, filename) {
      var content;
      content = 'module.exports = ' + Handlebars.precompile(
        fs.readFileSync(filename, 'utf8')
      )

      return module._compile(content, filename)
    }
  }
  return createPackageFn(config)
}

module.exports = stitch
