var Backbone = require('backbone')

module.exports = Backbone.Router.extend({
  createExpressRoute: function(app, route, fn) {
    app.get('/' + route, function(req, res) {
      fn(function(err, output) {
        if (err) {
          throw new Error(err.message)
        }
        res.end(output)  
      })
    })
  },
  initialize: function(options) {
    var that = this
    that.server = false

    if (options.routes) {
      that.routes = options.routes
    } 
   
    // Add express routes 
    for (route in that.routes) {
      if (typeof(that.routes[route]) === 'function') {
        continue
      }

      var fnName = that.routes[route]
      var fn = that.routes[fnName]
      that.createExpressRoute(options.app, route, fn)
    }
  },
})

